/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the AccountRecoveryInitData type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AccountRecoveryInitData{}

// AccountRecoveryInitData struct for AccountRecoveryInitData
type AccountRecoveryInitData struct {
	Email string `json:"email"`
}

// NewAccountRecoveryInitData instantiates a new AccountRecoveryInitData object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAccountRecoveryInitData(email string) *AccountRecoveryInitData {
	this := AccountRecoveryInitData{}
	this.Email = email
	return &this
}

// NewAccountRecoveryInitDataWithDefaults instantiates a new AccountRecoveryInitData object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAccountRecoveryInitDataWithDefaults() *AccountRecoveryInitData {
	this := AccountRecoveryInitData{}
	return &this
}

// GetEmail returns the Email field value
func (o *AccountRecoveryInitData) GetEmail() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Email
}

// GetEmailOk returns a tuple with the Email field value
// and a boolean to check if the value has been set.
func (o *AccountRecoveryInitData) GetEmailOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Email, true
}

// SetEmail sets field value
func (o *AccountRecoveryInitData) SetEmail(v string) {
	o.Email = v
}

func (o AccountRecoveryInitData) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AccountRecoveryInitData) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["email"] = o.Email
	return toSerialize, nil
}

type NullableAccountRecoveryInitData struct {
	value *AccountRecoveryInitData
	isSet bool
}

func (v NullableAccountRecoveryInitData) Get() *AccountRecoveryInitData {
	return v.value
}

func (v *NullableAccountRecoveryInitData) Set(val *AccountRecoveryInitData) {
	v.value = val
	v.isSet = true
}

func (v NullableAccountRecoveryInitData) IsSet() bool {
	return v.isSet
}

func (v *NullableAccountRecoveryInitData) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAccountRecoveryInitData(val *AccountRecoveryInitData) *NullableAccountRecoveryInitData {
	return &NullableAccountRecoveryInitData{value: val, isSet: true}
}

func (v NullableAccountRecoveryInitData) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAccountRecoveryInitData) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


